function f = llf(theta, outflag, fname)

% this function computes the log likelihood given the parameter vector theta

eval(['load set_PPI_bb_t' fname(end)])

beta(1) = theta(1);
beta(2) = theta(2);
alpha = theta(3);

stlike = 10;
msizeval = theta(4:end);

thetahat = DP_PPI(alpha, beta, msizeval, fname(4:5));

NUtab = -logninv([eps:NUntev:1],log(-m),s)';
Itab = (0:Intev:Imax)';
szI = size(Itab,1); szNU = size(NUtab,1);

optCtab = zeros(szI, szNU);
for i = 1:szI
    for j = 1:szNU
       if -NUtab(j) >= Itab(i); 
           optCtab(i,j) = Itab(i);
       else
           [stam1 i1] = max(allutil((-NUtab(j):0.5:150)',thetahat(2:daprox+1),delta,alpha,beta,NUtab(j),Itab(i), daprox));
           optCtab(i,j) = -NUtab(j) + (i1-1)*0.5;
       end
    end
end
optCtab = min(optCtab, Itab*ones(1,szNU));

eval(['load datai_' fname])

optCC = zeros(I,numsz+1);
Eri = zeros(I,size(Er,2));

lastHH = max(HHid);
ll = zeros(sum(diff(HHid)~=0)+1,1);
irow = 1;
iHH =1;

for hh = 1:lastHH
   HHlen = sum(HHid==hh);
   rand('state',0);
   invatstart = 50+150*rand(I,1);
   prob1 = ones(I,1);
   if HHlen > 0
   for h = 1:HHlen
      cshocks = all_cshocks(:,irow);
 
      omegai1 = omegai(irow,:);
      omegahat = (AR0 + AR1*omegai1' + ddum*(omegai1==-100)')';
      Eri(:,daprox+2:daprox+numsz+1) = ones(I,1)*omegahat; 
      Eri(:,daprox+numsv+1:daprox+numsv+numsz) = ones(I,1)*(omegahat.^2 + sig.^2); 

      ind1 = max(floor(min((invatstart)*ones(1,numsz+1) + ones(I,1)*sizes,Imax)/Intev)+1,1);
      ind2i = ind2(:,irow)*ones(1,numsz+1);

      ind = sub2ind([szI szNU],ind1, ind2i);
      optCC = reshape(optCtab(ind),[I numsz+1]);	
      inv2 = invatstart*ones(1,numsz+1) + ones(I,1)*sizes - optCC;
      for i=1:numsz+1
        for j=1:daprox
            Eri(:,j+1) = log(inv2(:,i)).^j; 
        end
        evVi(:,i) = Eri*thetahat;
      end
         
      eg1 = ones(I,1)*[0 omegai1+msizeval] + ufromC(optCC, cshocks*ones(1,numsz+1),alpha) - cofInv(inv2,beta) + delta*evVi;
      eg1 = eg1 - mean(eg1,2)*ones(1,numsz+1);
      eg = exp(eg1);
      prcondInu = eg./(sum(eg,2)*ones(1,numsz+1));

      if h > stlike
          prob1 = prob1.* prcondInu(:,puri(irow)+1);
      end

          invatstart = invatstart + sizes(puri1(irow)+1) - optCC(:,puri1(irow)+1) + addpur(irow);
      irow = irow + 1;

    end 
    ll(iHH) = log(mean(prob1));
    iHH = iHH +1;
   end 
end 

if outflag == 1 
    f = ll;
else
    f = - sum(ll);
end
