#delimit ;
set more 1;
set mem 100m;
set matsize 800;
log using 1st_stage.log, replace;


use 1st_data;
quietly tab brcode, gen(cdum);

clogit choice price, group(g);
clogit choice price cdum*, group(g);
clogit choice price fdum ddum cdum*, group(g);
clogit choice price pm1 prdum plfam fdum ddum cdum*, group(g);
clogit choice price pm1 prdum plfam fdum ddum cdum* cdf* cdm* cdr*, group(g);
clogit choice price pm1 prdum plfam fdum ddum ibdum*, group(g);

quietly for var ibdum1-ibdum722: replace X=X*size;
clogit choice price pm1 prdum plfam ibdum*, group(g);
clogit choice price pm1 prdum plfam fdum ddum ibdum*, group(g);

for new cdsz1-cdsz21 \ var cdum1-cdum21: gen X=Y*size;
clogit choice price pm1 prdum plfam fdum ddum cdsz* , group(g);

gen temp=size*100+brcode;
quietly tab temp, gen(cszdum);

clogit choice price pm1 prdum plfam fdum ddum cszdum*, group(g);

log close;
