function thetahat = DP_PPI(alpha, beta, msizeval, fname)

% this function solves the DP problem using parametric policy iteration 

load set_PPI

dis = 100; 

theta = [alpha beta msizeval];
u1 = [svar(:,numsz+3) svar(:,2:numsz+1)+svar(:,numsz+4:2*numsz+3)+ ones(ns,1)*msizeval];
eval(['load oldres_' fname])
thetahat1 = thetahat;

Istar = zeros(ns, numsz+1); k=1; optCC = zeros(ns,numsz+1); 

while dis>1e-3*10^floor(k/10)
    inv1 = svar(:,1) + sizes(optX)' - optC + eps;
    for i=1:daprox
        Er(:,i+1) = log(inv1).^i; 
    end
    ind1 = [1:ns]' + ns*(optX-1);
	immedu = u1(ind1) + ufromC(optC,svar(:,numsz+2),alpha) - cofInv(inv1,beta);
    X = r - delta*Er;
    thetahat = inv(X'*X)*X'*immedu;

    t1 = svar(:,1)*ones(1,numsz+1) + ones(ns,1)*sizes;
    for i = 1:ns
        e =  svar(i,numsz+2);
        z1 = ones(size((-e:1:250)'));
        [stam1 i1] = max(allutil((-e:1:250)'*ones(1,5),thetahat(2:daprox+1),delta,alpha,beta,e,z1*t1(i,:), daprox));
        optCC(i,:) = -e + (i1-1);
    end
    optCC = min(optCC, t1);
    Istar = svar(:,1)*ones(1,numsz+1) + ones(ns,1)*sizes - optCC + eps;
   	for i=1:numsz+1
        for j=1:daprox
            Er(:,j+1) = log(Istar(:,i)).^j; 
        end
  	    EVhat(:,i) = Er*thetahat;
	end
  	U1 = ufromC(optCC,svar(:,numsz+2)*ones(1,numsz+1),alpha) + [zeros(ns,1) svar(:,2:numsz+1)+ones(ns,1)*msizeval] + ...
   	    svar(:,numsz+3:2*numsz+3) - cofInv(Istar,beta) + delta*EVhat;
	[stam1, optX] = max(U1');
	optX = optX';
	ind1 = [1:ns]' + ns*(optX-1);
	optC = optCC(ind1);

   dis = mean(abs(r(:,2:end)*(thetahat(2:end)-thetahat1(2:end))./(r(:,2:end)*thetahat(2:end))));
   thetahat1=thetahat; 
   k = k +1;
end
