% this files runs the likelihood search for llf_PPI

diary results.txt 
load starval

[est_bb_t1 ll_bb_t1]= fminsearch('llf', est_bb_t1,options,0,'bb_t1')
[est_bb_t2 ll_bb_t2]= fminsearch('llf', est_bb_t2,options,0,'bb_t2')
[est_bb_t3 ll_bb_t3] = fminsearch('llf', est_bb_t3,options,0,'bb_t3')
[est_bb_t4  ll_bb_t4]= fminsearch('llf', est_bb_t4,options,0,'bb_t4')
[est_bb_t5  ll_bb_t5]= fminsearch('llf', est_bb_t5,options,0,'bb_t5')
[est_bb_t6  ll_bb_t6]= fminsearch('llf', est_bb_t6,options,0,'bb_t6')

vcov_bb_t1 = se_llf(est_bb_t1, 'llf' , 'bb_t1');
vcov_bb_t2 = se_llf(est_bb_t2, 'llf' , 'bb_t2');
vcov_bb_t3 = se_llf(est_bb_t3, 'llf' , 'bb_t3');
vcov_bb_t4 = se_llf(est_bb_t4, 'llf' , 'bb_t4');
vcov_bb_t5 = se_llf(est_bb_t5, 'llf' , 'bb_t5');
vcov_bb_t6 = se_llf(est_bb_t6, 'llf' , 'bb_t6');
[est_bb_t1 est_bb_t2 est_bb_t3 est_bb_t4 est_bb_t5 est_bb_t6; ...
 sqrt(diag(vcov_bb_t1))' sqrt(diag(vcov_bb_t2))' sqrt(diag(vcov_bb_t3))' ...
sqrt(diag(vcov_bb_t4))' sqrt(diag(vcov_bb_t5))' sqrt(diag(vcov_bb_t6))']'   
    
diary off